UNIT graphx;

(*
 Apr.1999 by Frederik Arbeiter	<Frederik.Arbeiter@gmx.net>
 This program if free software as defined in the General Public License (GPL)
 published by the Free Software Foundation (FSF)
*)

INTERFACE

USES
 strings, graph, crt, fdesk;

CONST
 STDBGIPATH	='\OPT\TURBO\BGI';
 transparent	=-1;

VAR
 colorset:
  record
   bc, tc, hc, cc	:byte;
  end;

FUNCTION findBGIPATH:string;
FUNCTION modeVGAHI(path:string):boolean;
PROCEDURE waitRetrace;
PROCEDURE graphCls(c:integer);
PROCEDURE wipe(x1, y1, x2, y2:integer;bc, fs:integer);
PROCEDURE box(x1, y1, x2, y2:integer;bc, fc, fs:integer);
PROCEDURE screen(title:string;x1,y1,x2,y2,bcolor,fcolor,fs:integer);
PROCEDURE printXY(x,y,bc,tc:integer;s:string);
PROCEDURE tildeTextXY(x, y, tc, hc:integer;s:string);
PROCEDURE inputXY(x,y,bc,tc:integer;var s:string);
FUNCTION sInput(s:string;v:string;d:byte;getval:boolean):string;
FUNCTION rInput(s:string;v:real;d:byte;getval:boolean):real;


IMPLEMENTATION

{$I GRAPHX.INC}

BEGIN
 colorset.bc := 0;
 colorset.tc := 7;
 colorset.hc := 15;
 colorset.cc := yellow;
END.