(*
 mathematische funktionen
 deklariere :
TYPE
 mathfun    = function(x, t:real):real;
*)


CONST
 largenum = 32000;
 smallnum = 1/largenum;
 {terry is meant to debug functions ,e.g for i := 1 to maxterry do pot(2 ,terry[i]) }
 maxTerry = 20;
 terry:array[0..maxterry] of real =(0 ,1 ,2 ,3 ,5 ,7 ,-1 ,-2 ,-3 ,-5 ,-7 ,
									0.1 ,0.2 ,0.3 ,0.5 ,0.7 ,-0.1 ,-0.2 ,-0.3 ,-0.5 ,-0.7 );

VAR
 matherr    :integer;

FUNCTION matherror:boolean;
 begin
  matherror:=(matherr <> 0);
  matherr := 0;
 end;

FUNCTION fracnum(x:real):boolean;
 begin
  fracnum:=(int(x) <> x);
 end;

FUNCTION pot(x ,e:real):real;
 var
  rval  :real;
 begin
  if x>0
	then rval:=exp(e*ln(x));
  if x=0
	then rval:=0;
  if x<0
	then begin
	 if fracnum(e)
	  then begin
	   matherr := 1;
	  end
	  else begin
	   rval:=exp(e*ln(abs(x)));
	   if odd(round(e))
		 then rval:=-rval;
	  end;
	end;
  pot:=rval;
 end;

FUNCTION fak(n:byte):real;
 var
  rval  :real;
  i :word;
 begin
  rval:=1;
  if (n=0) or (n>69)
	then begin
	 if n=0
	   then rval:=1
	   else begin
		matherr := 1;
		rval := 0;
	   end;
	end
	else for i:=1 to n do
			 rval:=rval*i;
  fak:=rval;
 end;

FUNCTION tan(x :real):real;
 begin
  tan := sin(x) / cos(x);
 end;

FUNCTION log(base ,x:real):real;
 begin
  log := ln(x) /ln(base);
 end;

FUNCTION sgn(r :real):integer;
 var
  rval  :integer;
 begin
  if r>=0 then rval:=1;
  if r<0 then rval:=-1;
  sgn := rval;
 end;

FUNCTION abl(f:mathfun; grad:word; delta, x, t:real):real;
{
berechnet rekursiv den  grad.
grad der ableitung von f(x,t)
an der stelle x
}
 var
  rval  :real;
 begin
  if grad = 0
	then rval := f(x, t);
  if grad > 0
	then rval := (abl(f, grad-1, delta, x+delta/2, t) - abl(f, grad-1, delta, x-delta/2, t))/delta;
  abl := rval;
 end;


function cycle(X,VECT,BOTTON,TOP:integer):integer;
var
 SSUM:integer;
begin
 SSUM:=X+VECT;
 if (SSUM>=BOTTON) and (SSUM<=TOP) then X:=SSUM;
 if SSUM<BOTTON then X:=TOP-1- (SSUM MOD (TOP-BOTTON+1));{X:=BOTTON-SSUM;  }
 if SSUM>TOP    then X:=BOTTON+(SSUM-TOP-1);
 cycle:=X;
end;

procedure cinc(var x:integer;vect,bottom,top:integer);
begin
 inc(x,vect);
 if x>top then x:=bottom;
 if x<bottom then x:=top;
end;

FUNCTION alpha_b(alpha:real):real;
 begin
  alpha_b :=  alpha*pi/180;
 end;

FUNCTION b_alpha(b:real):real;
 begin
  b_alpha :=  b*180/pi;
 end;

FUNCTION ranging(x ,low ,high:real):boolean;
 begin
  ranging := ((x>=low) and (x<=high))
 end;

FUNCTION pyth2D(a, b:real):real;
 begin
  pyth2D := sqrt(sqr(a) + sqr(b));
 end;

FUNCTION pyth3D(a, b, c:real):real;
 begin
  pyth3D := sqrt(sqr(a) + sqr(b) + sqr(c));
 end;
