UNIT strings;

{
tools to use pascal strings
}

(*
 Apr.1999 by Frederik Arbeiter	<Frederik.Arbeiter@gmx.net>
 This program if free software as defined in the General Public License (GPL)
 published by the Free Software Foundation (FSF)
*)

INTERFACE

 TYPE
  string3	=string[3];
  string8	=string[8];
  string80	=string[80];

 FUNCTION upStr(s:string):string;
 FUNCTION strOf(r:real;d:byte):string;
 FUNCTION strOfInt(l:longint):string;
 FUNCTION strOf_(r:real):string;
 FUNCTION strCut(s:string ;ss:string):string;
 FUNCTION rmStr(ss:string ;s:string):string;
 FUNCTION rpStr(os ,ns ,s:string):string;
 FUNCTION xorStr(s:string;c:byte):string;
 FUNCTION orStr(s:string;c:byte):string;
 FUNCTION andStr(s:string;c:byte):string;
 FUNCTION shiftStr(s:string;v:integer):string;
 FUNCTION posN(ss, s:string;n:byte):byte;
 FUNCTION lPos(ss, s:string):byte;
 FUNCTION getItem(s:string;n:byte;fill:string):string;
 FUNCTION countSubstring(s, ss:string):byte;


{
system provides :
Copy(s, i, l):string;
Concat(a, b):string;
Delete(s, i, l);
Insert(ss, s, i)
Pos(ss, s);
Length(s):byte
}

IMPLEMENTATION

{$I STRINGS.INC}

END.