(*
 11051996
 Diese Datei enthlt einfachste Hilfsfunktionen
 fr textbasierte Benutzeroberflchen.
 in Hauptprogramm wird bentigt :
 USES
  crt
VAR
 MSGROW	:byte;
*)

PROCEDURE colors(b, t:byte);
{
 Setzt Farben fr nachfolgende Textausgaben
}
 begin
  textAttr := t + b shl 4;
 end;

PROCEDURE cls(c:byte);
{
 Lscht den Textbildschirm in Farbe c
}
 begin
  textBackground(c);
  clrScr;
 end;

PROCEDURE at(x ,y:integer ;s:string);
{
 setzt String s  an (x|y)
}
 begin
  gotoxy(x ,y);
  write(s);
 end;

PROCEDURE frame(x1, y1, x2, y2:integer ;title:string);
{
 Zeichnet Rahmen mit berschrift
}
 var
  h ,v ,clu ,clo ,cru ,cro:char;
  i ,loc:byte;
 begin
   h:='';v:='';clu:='';clo:='';cru:='';cro:='';
   for i:=x1 to x2 -1 do
     at(i ,y2 -1 ,h);
   for i:=x1 to x2 -1 do
     at( i,y1 ,h);
   for i:=y1 to y2 -1 do
     at(x1 ,i ,v);
   for i:=y1 to y2 -1 do
     at(x2 -1 ,i ,v);

   at(x1, y1, clo);
   at(x1 ,y2 -1 ,clu);
   at(x2 -1 ,y1 ,cro);
   at(x2 -1 ,y2 -1 ,cru);
   loc:=x1 +(x2-x1) div 2 -length(title) div 2;
   at(loc, y1, title);
 end;


PROCEDURE headline(bc, tc:byte;s:string);
{
 schreibt farbigen Text in Zeile 1
 restauriert dann wieder Textausgaben Variablen.
}
 var
  x1, y1, x2, y2	:byte;
  x, y			:byte;
  ta			:byte;
 begin
  x1:=lo(windMin)+1;
  x2:=lo(windMax)+1;
  y1:=hi(windMin)+1;
  y2:=hi(windMax)+1;
  x := whereX;
  y := whereY;
  window(1, 1, 80, 25);
  ta := textAttr;
  textAttr := tc + bc shl 4;
  gotoXY(1, 1);
  clrEol;
  write(s);
  textAttr := ta;
  window(x1, y1, x2, y2);
  gotoXY(x, y);
 end;


PROCEDURE statusLine(bc, tc:byte;s:string);
{
 schreibt Text in Zeile 25
 restauriert dann wieder Textausgaben Variablen.
}
 var
  x1, y1, x2, y2	:byte;
  x, y			:byte;
  ta			:byte;
 begin
  x1:=lo(windMin)+1;
  x2:=lo(windMax)+1;
  y1:=hi(windMin)+1;
  y2:=hi(windMax)+1;
  x := whereX;
  y := whereY;
  window(1, 1, 80, 25);
  ta := textAttr;
  textAttr := tc + bc shl 4;
  gotoXY(1, 25);
  clrEol;
  write(s);
  textAttr := ta;
  window(x1, y1, x2, y2);
  gotoXY(x, y);
 end;

PROCEDURE emptyKbd;
{
 lscht Tastaturpuffer
}
 begin
  while keyPressed do
    readKey;
 end;

FUNCTION getKeys(var c1, c2:char):byte;
{
 wartet auf Taste und bergibt char + evtl extended.
 funktionswert liefert 2 , wenn extendedkey, sonst 1
}
 var
  rval	:byte;
 begin
  c2 := #0;
  rval := 1;
  repeat
  until KeyPressed;
  c1 := readKey;
  if keyPressed
    then begin
     c2 := readKey;
     rval := 2;
    end
    else begin
     c2 := #0;
     rval := 1;
    end;
  getKeys := rval;
 end;

FUNCTION waitMessage(s:string):char;
{
 zeigt Message an und wartet auf Tastendruck
 Taste wird zurckgegeben
}
 begin
  while keyPressed do
    readKey;
  if s[1] = #13
    then writeLn;
  if s = '!'
    then s := ' Please press your favourite key to continue.';
  writeLn(s);
  waitMessage := readKey;
 end;

FUNCTION choice(s:string):boolean;
{
 Ermittelt Ja/Nein Eingaben, Ja = true.
 Now in English Y for yes = true
}
 var
  c	:char;
 begin
  colors(colorset.bc, colorset.tc);
  if s[1] = #13
    then writeLn;
  write(s,' [Y/N] : ');
  repeat
   c := upCase(readKey);
  until c in ['Y', 'N', #13];
  if c = #13
    then c := 'Y';
  colors(colorset.bc, colorset.hc);
  writeLn(c);
  choice := (c = 'Y');
 end;

FUNCTION switch(s:string;val:boolean;getval:boolean):boolean;
var
 x, y	:integer;
 c1, c2	:char;
begin
x := whereX;
y := whereY;
if(getval) then
	textColor(colorset.hc)
else
	textColor(colorset.tc);
write(' [ ] ',s);
repeat
if(val) then
	at(x+2, y, 'X')
else
	at(x+2, y, ' ');
if(not getval)
	then break;
getKeys(c1, c2);
if(c1 in[' ']) then
	val := not val;
until (c1 in[#13, #26, #9]) or (c2 in[#15]);
switch := val;
end;

FUNCTION button(s:string;c:char;getval:boolean):boolean;
var
 rval	:boolean;
 c1, c2	:char;
begin
if(getval) then
	textColor(colorset.hc)
else
	textColor(colorset.tc);
write('[',s,' <',c,'>]');
if(not getval) then
	begin
    button := false;
	exit;
    end;
repeat
getKeys(c1, c2);
if(upCase(c1) = upCase(c)) then
	rval := true;
until (upCase(c1) in[#13, #26, #9, upCase(c)]) or (c2 in[#15]);
button := rval;
end;

FUNCTION strInput(s:string;v:string;d:byte;getval:boolean):string;
{
 String Eingabefunktion mit "preset".
 if not getval : nur textausgabe, ohne user abfrage (whrend aufbau einer dialogseite o..)
}
 var
  rval	:string;
  p, l	:byte;
  x, y	:integer;
  c1, c2:char;
 begin
  if s[1] = #13
    then writeLn;
  if(getval) then
  	textColor(colorset.hc)
  else
  	textColor(colorset.tc);
  if length(v) > d
    then v := copy(v, 1, d);
  rval := v;
  write(s, ' : ');
  textColor(colorset.hc);
  x := whereX;
  y := whereY;
  write(rval);
  clrEol;
  p := length(rval);
  if getval
   then repeat
    l := length(rval);
    getKeys(c1, c2);
    if (c2=#0) and (c1 in [#0..#7, #9, #11..#12, #14..#31, #32..#255]) {printable characters}
      then begin
       inc(p);
       insert(c1, rval, p);
      end;
    if (c1=#8) and (p>=1) {backspace}
     then begin
      rval := (copy(rval, 1, p-1)+copy(rval, p+1, l-p));
      dec(p);
     end;
    if (c2=#75) and (p>=1) {cursor to left}
      then dec(p);
    if (c2=#77) and (p<l) {cursor to right}
      then inc(p);
    if (c2=#71) {home}
      then p := 0;
    if (c2=#79) {end}
      then p := l;
    if (c2=#83) and (p<=l) {delete}
      then rval := (copy(rval, 1, p)+copy(rval, p+2, l-p));
    if length(rval) > d	{now test size...}
      then begin
       rval := copy(rval, 1, d);
       p := d;
      end;
    gotoXY(x, y);clrEol;
    write(rval);
    gotoXY(x+p, y);
    if (c1=#13)
      then break;
   until false;
  strinput := rval;
  if whereX <> 1
    then writeLn;
 end;

FUNCTION realInput(s:string;v:real;d:byte;getval:boolean):real;
{
 Numerische real Eingabefunktion mit "preset".
 Siehe auch strInput.
}
 var
  st	:string;
  rval	:real;
  test	:integer;
  x, y	:integer;
 begin
  if s[1] = #13
    then writeLn;
  textColor(colorset.tc);
  write(s);
  colors(colorset.bc, colorset.hc);
  rval := v;
  x := whereX;
  y := whereY;
  write(' : ', strOf_(rval));
  if getval
    then repeat
     test := 0;
     gotoXY(x, y{-1});clrEol;
     st := strInput('', strOf_(rval), 24, true);
     if pos(',', st) <> 0
       then st[pos(',', st)] := '.';
     if st = ''
       then rval := v
       else val(st, rval, test);
    until test = 0;
  gotoXY(x, y{-1});
  write(' : ', strOf_(rval));
  clrEol;
  realInput := rval;
  if whereX <> 1
    then writeLn;
 end;

FUNCTION intInput(s:string;v:real;d:byte;getval:boolean):longint;
{
 Numerische integer Eingabefunktion mit "preset".
 Siehe auch strInput.
}
 var
  st	:string;
  rval	:real;
  test	:integer;
  x, y	:integer;
 begin
  if s[1] = #13
    then writeLn;
  textColor(colorset.tc);
  write(s);
  colors(colorset.bc, colorset.hc);
  rval := v;
  x := whereX;
  y := whereY;
  write(' : ', strOf_(rval));
  if getval
    then repeat
     test := 0;
     gotoXY(x, y{-1});clrEol;
     st := strInput('', strOf_(rval), 24, true);
     if pos(',', st) <> 0
       then st[pos(',', st)] := '.';
     if st = ''
       then rval := v
       else val(st, rval, test);
    until test = 0;
  gotoXY(x, y{-1});
  write(' : ', strOf_(rval));
  clrEol;
  intInput := round(rval);
  if whereX <> 1
    then writeLn;
 end;

FUNCTION select(m, s:string):integer;
{
 Wahl aus WENIGEN verschiedenen Optionen,
 z.B m:='FARBE', s:='rot gelb violett';
}
 var
  i, j	:integer;
  x, y	:integer;
  rval	:longint;
  t, l	:integer;
 begin
  l := length(s);
  if s[1] <> #32
    then s := #32+s;
  if s[l] <> #32
    then s := s+#32;
  write(m,'  ');
  t := 0;
  i := 1;
  j := 1;
  repeat
   if (s[i] in [#32])
     then begin
      j := 1;
      inc(t);
      write('(',t,')=');
      inc(i);
     end;

   while not (s[i] in [#32]) do
    begin
     write(s[i]);
     inc(i);inc(j);
    end;
   if i<l
     then write(' ');
  until i >= l;
  write('  ');
   i := t;
  x := whereX;
  y := whereY;
  if y=hi(windMax)+1
    then begin
     writeLn;
     dec(y);
    end;
  repeat
   gotoXY(x, y);
   write(': ');clrEol;
   readLn(s);
   val(s, rval, t);
   if (t = 0) and (rval > 0) and (rval <= i)
     then break
     else write(#7);
  until false;
  select := rval;
 end;

FUNCTION menu(m,s:string):integer;
{
 Auswahlmenu ,
 z.B. m:='HAUPTMENU', s:='Laden Speichern Bearbeiten Konfigurieren, Beenden'
}
 var
  i, j	:integer;
  x, y	:integer;
  rval	:longint;
  t, l	:integer;
 begin
  colors(colorset.bc, colorset.hc);
  l := length(s);
  if s[1] <> #32
    then s := #32+s;
  if s[l] <> #32
    then s := s+#32;
  x := whereX;
  y := whereY;
  gotoXY(x, y);
  writeLn(m);
  t := 0;
  i := 1;
  j := 1;
  repeat

   if (s[i] in [#32])
     then begin
      j := 1;
      inc(t);
      gotoXY(x, y+1+t);
      write('(',t,') ');
      inc(i);
     end;

   while not (s[i] in [#32]) do
    begin
     gotoXY(x+j+4, y+t+1);
     write(s[i]);
     inc(i);inc(j);
    end;
   writeLn;

  until i >= l;

  i := t;
  repeat
   gotoXY(x, y+i+3);
   write('> ');clrEol;
   readLn(s);
   val(s, rval, t);
   if (t = 0) and (rval > 0) and (rval <= i)
     then break
     else write(#7);
  until false;
  menu := rval;
 end;

PROCEDURE tildeWriteXY(x,y,tc,hc:integer;s:string);
 var
  i, l, b	:integer;
 begin
  l := length(s);
  for i:=1 to l do
   begin
    if s[i] = '~'
     then begin
      textColor(hc);
      inc(i);
     end
     else textColor(tc);
     gotoXY(x, y);
     write(s[i]);
    inc(x);
   end;
 end;
