(*
tolle file funs
declare:
 TYPE
  anyfile	=file of byte;
*)

FUNCTION fileExist(path:string):boolean;
 var
  f:file;
 begin
  {$I-}
  assign(f,path);
  reset(f);
  close(f);
  {$I+}
  fileExist:=(IOresult=0);
 end;

FUNCTION dirExist(path:string):boolean;
 var
  keepdir:string;
  b_path:string;
 begin
  GetDir(0,keepdir);
  b_path:=path;
  {$I-}
  Chdir(b_path);
  {$I+}
  dirExist:=(IOresult=0);
  ChDir(keepdir);
 end;

FUNCTION textLines(var f:text):longint;
 var
  rval	:longint;
 begin
  {$I-}
  reset(f);
  {$I+}
  if IOresult <> 0
   then exit;
   rval := 0;
   while not eof(f) do
    begin
     readLn(f);
     inc(rval);
    end;
   reset(f);
  textLines := rval;
 end;

FUNCTION pathExpand(dir, name, ext:string):string;
 begin
  pathExpand := 'pathExpand not yet implemented';
 end;

PROCEDURE pathSplit(path:string;var dir, name, ext: string);
 var
  n, p, l	:integer;
 begin
  l := length(path);
 {get Extension}
  p := pos('.', path);
  if(p = 0) then
  	begin
	ext := '';
    p := l + 1;
    end
  else
   	ext := copy(path, p+1, 3);
 {get name}
  n := lPos('\', path);
  if(n = 0) then
  	n := pos(':', path);
  name := copy(path, n+1, p-n-1);
  {get directory}
  p := 0;
  dir := copy(path, p+1, n-p);
 end;
