UNIT math;

{
standart mathematic functions ,
implementation in math.inc
}

(*
 Apr.1999 by Frederik Arbeiter	<Frederik.Arbeiter@gmx.net>
 This program if free software as defined in the General Public License (GPL)
 published by the Free Software Foundation (FSF)
*)

INTERFACE

TYPE
 mathfun	= function(x, t:real):real;

 FUNCTION MATHerror:boolean;
 FUNCTION fracnum(x:real):boolean;
 FUNCTION pot(x ,e:real):real;
 FUNCTION fak(n:byte):real;
 FUNCTION tan(x :real):real;
 FUNCTION log(base ,x:real):real;
 FUNCTION sgn(r :real):integer;
 FUNCTION abl(f:mathfun; grad:word; delta, x, t:real):real;
 FUNCTION pyth2D(a, b:real):real;
 FUNCTION pyth3D(a, b, c:real):real;

 FUNCTION cycle(X,VECT,BOTTON,TOP:integer):integer;
 PROCEDURE cinc(var x:integer;vect,bottom,top:integer);
 FUNCTION ranging(x ,low ,high:real):boolean;

 FUNCTION alpha_b(alpha:real):real;
 FUNCTION b_alpha(b:real):real;

IMPLEMENTATION

{$I MATH.INC}

END.