PROGRAM STARMAP;

{$I compopt.086}

(*
 Copyright by Frederik Arbeiter
 * 01.05.1997

 This is all ... uh ...  CRAP !
 Please don't view the code. It's vulgar.
*)

USES
 param, crt,
 strings,
 graph, graphx;

TYPE
 systemType=
  record
   x, y		:integer;
   name		:string[20];
  end;

 rangeType=
  record
   x1, y1, x2, y2	:integer;
   identif			:string[40];
  end;

  cfile	=file of char;

VAR
 xyF		:file of integer;
 nmF		:cfile;
 txF		:text;
 id, i		:integer;
 planet		:array[1..500] of systemType;
 x, y, d	:integer;
 range		:array[0..4] of rangeType;
 rangeid	:integer;
 c			:char;
 dots		:integer;
 iddraw		:boolean;
 grid		:boolean;

PROCEDURE putStars(range:rangeType);
 var
  gx, gy	:integer;
  i			:integer;
 begin
 clearDevice;
 setTextStyle(SMALLFONT, HORIZDIR, 4);
 printXY(495, 15, 0, 15, '*** The Echo Cluster ***');
 printXY(520, 30, 0, 15, '< '+range.identif+' >');
 printXY(520, 50, 0, 15, 'Extensions:');
 printXY(520, 60, 0, 15, 'WE ('+strOfInt(range.x1)+'..'+strOfInt(range.x2)+')       ');
 printXY(520, 70, 0, 15, 'NS ('+strOfInt(range.y1)+'..'+strOfInt(range.y2)+')       ');
 if(grid = true) then
 	begin
    setLineStyle(DOTTEDLN, 0, 1);
 	setColor(7);
 	rectangle(0, 0, 479, 479);
 	for i:= 1 to 9 do
 		begin
    	line(0,round(i*479/10), 479, round(i*479/10));
    	line(round(i*479/10), 0, round(i*479/10), 479);
    	end;
 	end;
 for i := 1 to 500 do
 	begin
    if((planet[i].x >= range.x1) and (planet[i].x <= range.x2) and
	   (planet[i].y >= range.y1) and (planet[i].y <= range.y2)) then
    	begin
        {printXY(500, 400, 0, yellow, strOfInt(i));}
        gx := round((planet[i].x -range.x1)*(479/(range.x2-range.x1)));
        gy := 479-round((planet[i].y -range.y1)*(479/(range.y2-range.y1)));
        if(dots = 2) then
        	begin
            setColor(white);
			setLineStyle(SOLIDLN, 0, 1);
        	line(gx-1, gy-1, gx+1, gy-1);
        	line(gx-1, gy, gx+1, gy);
        	line(gx-1, gy+1, gx+1, gy+1);
        	end;
        if(dots = 0) then
        	putPixel(gx, gy, 15);
        if(dots = 1) then
        	begin
            setColor(white);
			setLineStyle(SOLIDLN, 0, 1);
            line(gx-1, gy, gx+1, gy);
            line(gx, gy-1, gx, gy+1);
            end;
        setTextStyle(SMALLFONT, HORIZDIR, 4);
        setColor(7);
        if(iddraw) then
			outTextXY(gx, gy, strOfInt(i));
        end;
    end;
 end;


BEGIN {main}
 dots := 0;
 iddraw := FALSE;
 grid := TRUE;
 writeLn('*** STARMAP OF THE ECHO CLUSTER ***');
 writeLn;
 writeLn('Specify path to egavga.bgi and litt.chr in option');
 writeLn('starmap /BGI:<bgipath> or copy these files to the current directory');
 writeLn;
 writeLn('Valid keys are 0..4 to select sector,');
 writeLn('g :grid, i:idnumbers, d:dotstyle <ESC> to quit');
 writeLn('Use the PrtScr key to make screen hardcopies for printed maps.');
 writeLn;
 writeLn('Press <RETURN> now to continue');
 readLn;
 writeLn('Reading 500 planets from .\xyplan.dat');
 {$I-}
 assign(xyF, 'xyplan.dat');
 reset(xyF);
 {$I+}
 if(IOresult <> 0) then
 	abort(1, 'cannot open xyplan.dat for read');
 (*
 {$I-}
 assign(nmF, 'planet.nm');
 reset(nmF);
 {$I+}
 if(IOresult <> 0) then
 	abort(1, 'cannot open planet.nm for read');
 *)
 for id := 1 to 500 do
    begin
 	read(xyF, planet[id].x);
 	read(xyF, planet[id].y);
 	read(xyF, d);
    (*
    planet[id].name[0] := #20;
    for i:=1 to 20 do
		read(nmF, planet[id].name[i]);
    *)
    end;
 delay(2000);
 close(xyF);
 (*close(nmF);*)
 with range[0] do
 	begin
    x1 := 1000;
    y1 := 1000;
    x2 := 3000;
    y2 := 3000;
    identif := 'All quadrants   '
    end;
 with range[1] do
 	begin
    x1 := 2000;
    y1 := 2000;
    x2 := 3000;
    y2 := 3000;
    identif := 'Sector 1, NE  '
    end;
 with range[2] do
 	begin
    x1 := 1000;
    y1 := 2000;
    x2 := 2000;
    y2 := 3000;
    identif := 'Sector 2, NW  '
    end;
 with range[3] do
 	begin
    x1 := 1000;
    y1 := 1000;
    x2 := 2000;
    y2 := 2000;
    identif := 'Sector 3, SW  '
    end;
 with range[4] do
 	begin
    x1 := 2000;
    y1 := 1000;
    x2 := 3000;
    y2 := 2000;
    identif := 'Sector 4, SE  '
    end;
 rangeid := 0;
 if not modeVGAHI(findBGIPATH) then
 	modeVGAHI('');
 clearDevice;
 repeat
 putStars(range[rangeid]);
 c := (readkey);
 while keypressed do readkey;
 if(c = 'g') then
 	grid := not grid ;
 if(c = 'd') then
 	inc(dots);
 if(dots > 2) then
 	dots := 0;
 if(c = 'i') then
 	iddraw := not iddraw;
 if c = #27 then
 	break;
 if(c in['0'..'4']) then
 	begin
 	rangeid := ord(c) - ord('0');
    end;
 until false;
clrscr;
writeLn;
writeLn('STARMAP copyright notice');
writeLn('Ahem...');
writeLn('This software is freely distributable but comes with no warranty.');
writeLn('Thank you.');
writeLn;
END.  {main}
